"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectMulti = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _react = _interopRequireDefault(require("react"));

var _uiSchema = require("@ui-schema/ui-schema");

var _immutable = require("immutable");

var _LocaleHelperText = require("../../Component/LocaleHelperText/LocaleHelperText");

var SelectMulti = (0, _uiSchema.extractValue)((0, _uiSchema.memo)(function (_ref) {
  var schema = _ref.schema,
      storeKeys = _ref.storeKeys,
      showValidity = _ref.showValidity,
      errors = _ref.errors,
      ownKey = _ref.ownKey,
      value = _ref.value,
      _onChange = _ref.onChange,
      required = _ref.required;

  var _useUIMeta = (0, _uiSchema.useUIMeta)(),
      t = _useUIMeta.t;

  if (!schema) return null;
  var oneOfValues = schema.getIn(['items', 'oneOf']);
  if (!oneOfValues) return null;
  var classForm = ['selectpicker', 'custom-select'];
  var classFormParent = ['form-group'];

  if (showValidity && errors.hasError()) {
    classForm.push('is-invalid');
  }

  if (showValidity && !errors.hasError()) {
    classForm.push('was-validated');
  }

  var currentValue = typeof value !== 'undefined' ? value : schema.get('default') ? (0, _immutable.List)(schema.get('default')) : (0, _immutable.List)([]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classFormParent.join(' ')
  }, /*#__PURE__*/_react["default"].createElement("label", null, /*#__PURE__*/_react["default"].createElement(_uiSchema.TransTitle, {
    schema: schema,
    storeKeys: storeKeys,
    ownKey: ownKey
  })), /*#__PURE__*/_react["default"].createElement("select", {
    value: currentValue.toArray(),
    className: classForm.join(' '),
    multiple: true,
    onChange: function onChange(e) {
      var target = e.target;

      _onChange({
        storeKeys: storeKeys,
        scopes: ['value'],
        type: 'update',
        updater: function updater() {
          return {
            value: (0, _uiSchema.sortScalarList)((0, _immutable.List)((0, _toConsumableArray2["default"])(target.options).filter(function (o) {
              return o.selected;
            }).map(function (o) {
              return o.value;
            })))
          };
        },
        schema: schema,
        required: required
      });
    }
  }, oneOfValues ? oneOfValues.map(function (oneOfSchema) {
    var oneOfVal = oneOfSchema.get('const') + '';
    var Translated = t(oneOfVal, (0, _immutable.Map)({
      relative: (0, _immutable.List)(['title'])
    }), oneOfSchema.get('t'));
    return /*#__PURE__*/_react["default"].createElement("option", {
      key: oneOfVal,
      value: oneOfVal,
      defaultValue: currentValue.toArray().includes(oneOfVal)
    }, typeof Translated === 'string' || typeof Translated === 'number' ? Translated : (0, _uiSchema.beautifyKey)(oneOfVal, oneOfSchema.get('tt')));
  }).valueSeq() : null), /*#__PURE__*/_react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }));
}));
exports.SelectMulti = SelectMulti;